#include <sys/types.h>
#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <signal.h>
#include <string.h>

static void sigHandler(
	int sigNum)
{
	printf("sigHandler\n");
}

int main(int argc, char **argv)
{
	SIG_ACTION action = {
		.sa_handler = sigHandler,
	};

	if (sigaction(SIGUSR1, &action, NULL) != 0) {
		printf("sigaction error!\n");
		return 0;
	}
	
	kill(getpid(), SIGUSR1);

	return 0;
}
